#pragma once

#include "GameFramework/Actor.h"
#include "Voice.h"
#include "OnlineSubsystemUtils.h"
#include "Sound/SoundWaveProcedural.h"
#include "AudioActor.generated.h"

UCLASS()
class SHOUTBAT_API AAudioActor : public AActor
{
	GENERATED_BODY()

public:
	// Sets default values for this actor's properties
	AAudioActor();

	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

	// Called every frame
	virtual void Tick(float DeltaSeconds) override;

	UPROPERTY(VisibleAnywhere, BlueprintReadWrite, Category = "Voice")
		bool AudioAtivo;

	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Voice")
		float VoiceCaptureVolume;

	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Voice")
		bool VoiceCaptureTest;
	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Voice")
		bool PlayVoiceCaptureFlag;

	UPROPERTY()
		FTimerHandle VoiceCaptureTickTimer;
	UPROPERTY()
		FTimerHandle PlayVoiceCaptureTimer;

	TSharedPtr<class IVoiceCapture> VoiceCapture;

	UPROPERTY()
		USoundWaveProcedural* VoiceCaptureSoundWaveProcedural;
	UPROPERTY()
		UAudioComponent* VoiceCaptureAudioComponent;

	UPROPERTY()
		TArray<uint8> VoiceCaptureBuffer;

	UFUNCTION()
		void VoiceCaptureTick();

	UFUNCTION()
		void PlayVoiceCapture();

	UFUNCTION()
		void InitSoundProcedural();

};
